import java.util.*;

public class AnimalPen {
    public List<ZooAnimal> animals = new LinkedList<>();

    public AnimalPen(Animal animal, int count) {
        for (int i = 0; i < count; i++) {
            ZooAnimal newAnimal = new ZooAnimalClass(animal.name());
            animals.add(newAnimal);
        }
    }

    public AnimalPen(Animal animal1, Animal animal2, int count1, int count2) {
        for (int i = 0; i < count1; i++) {
            ZooAnimal newAnimal = new ZooAnimalClass(animal1.name());
            animals.add(newAnimal);
        }

        for (int i = 0; i < count2; i++) {
            ZooAnimal newAnimal = new ZooAnimalClass(animal2.name());
            animals.add(newAnimal);
        }
    }

    @Override
    public String toString() {
        HashMap<String, Integer> animalCounts = new HashMap<>();

        for (ZooAnimal animal : animals) {
            if (animalCounts.get(animal.getName()) == null) {
                animalCounts.put(animal.getName(), 1);
            } else {
                int previousCount = animalCounts.get(animal.getName());
                animalCounts.put(animal.getName(), previousCount + 1);
            }
        }

        String animalsInPen = "";
        boolean first = true;

        for (Map.Entry<String, Integer> nameAndCount : animalCounts.entrySet()) {
            if (first) {
                first = false;
            } else {
                animalsInPen += ", ";
            }

            animalsInPen += nameAndCount.getValue();
            animalsInPen += " ";
            animalsInPen += nameAndCount.getKey();

            if (nameAndCount.getValue() > 1) {
                animalsInPen += "s";
            }
        }

        return animalsInPen;
    }

    public boolean hasEvent() {
        return !getEvents().isEmpty();
    }

    public List<String> getEvents() {
        ArrayList<String> processedAnimals = new ArrayList<>();
        LinkedList<String> events = new LinkedList<>();

        for (ZooAnimal animal : animals) {
            if (processedAnimals.contains(animal.getName())) {
                continue;
            } else {
                processedAnimals.add(animal.getName());
                ZooAnimalClass animalClass = (ZooAnimalClass) animal;
                if (isBrilliantBird(animalClass)) {
                    events.add("Feeding at " + ZooAnimal.brilliantBirdFeedingTime);
                } else if (isMonkey(animalClass)) {
                    events.add("Feeding at " + ZooAnimal.monkeyFeedingTime);
                } else if (animalClass.getName().equals("SunBear")) {
                    events.add("Feeding at " + ZooAnimal.sunBearFeedingTime);
                } else if (animalClass.getName().equals("Koala")) {
                    events.add("Feeding at " + ZooAnimal.koalaFeedingTime);
                }
            }
        }

        return events;
    }

    public boolean isBrilliantBird(ZooAnimalClass animalClass) {
        String name = animalClass.getName();
        if (name.equals("VictoriaCrownedPigeon")
                || name.equals("NicobarPigeon")
                || name.equals("RainbowLorikeet")
                || name.equals("ChestnutbackedThrush")) {
            return true;
        }
        return false;
    }

    public boolean isMonkey(ZooAnimalClass animalClass) {
        String name = animalClass.getName();
        return name.equals("CapuchinMonkey")
                || name.equals("Gibbon")
                || name.equals("Chimpanzee");
    }
}
