import java.util.ArrayList;
import java.util.List;

public class ZooNavigator {
    public List<Object> zooObjects;

    public ZooNavigator() {
        this.zooObjects = new ArrayList<>();
        populateZoo(this.zooObjects);
    }

    private void populateZoo(List<Object> objects) {
        objects.add(new AnimalPen(Animal.AsiaticLion, 1));
        objects.add(new AnimalPen(Animal.Tiger, 4));
        objects.add(new AnimalPen(Animal.HogDeer, 23));
        objects.add(new AnimalPen(Animal.Koala, 3));
        objects.add(new AnimalPen(Animal.Squirrel, Animal.CapuchinMonkey, 9, 7));
        objects.add(new AnimalPen(Animal.Vicuna, 15));
        objects.add(new AnimalPen(Animal.Nyala, Animal.LesserKudu, 4, 16));
        objects.add(new AnimalPen(Animal.SunBear, 2));
        objects.add(new Museum("Magic Forest"));
        objects.add(new AnimalPen(Animal.VictoriaCrownedPigeon, Animal.NicobarPigeon, 3, 8));
        objects.add(new AnimalPen(Animal.RainbowLorikeet, Animal.ChestnutbackedThrush, 6, 4));
        objects.add(new AnimalPen(Animal.Chimpanzee, 5));
        objects.add(new AnimalPen(Animal.Gibbon, 4));
        objects.add(new Restaurant("Grasslands Restaurant"));
        objects.add(new AnimalPen(Animal.Otter, 6));
        objects.add(new AnimalPen(Animal.VisayanWartyPig, 3));
        objects.add(new AnimalPen(Animal.Bongo, 5));
        objects.add(new AnimalPen(Animal.Cassowary, 6));
        objects.add(new AnimalPen(Animal.Wallaby, 5));
    }

    public void showWhatIsInTheZoo() {
        for (Object obj : zooObjects) {
            if (obj instanceof AnimalPen) {
                AnimalPen pen = (AnimalPen) obj;
                System.out.println("There is an animal pen for " + pen.toString());

                if (pen.hasEvent()) {
                    for (String event : pen.getEvents()) {
                        System.out.println(event);
                    }
                }
            }

            else if (obj instanceof Museum) {
                Museum museum = (Museum) obj;
                System.out.println("There is a museum called " + museum.toString());
            }

            else if (obj instanceof Restaurant) {
                Restaurant restaurant = (Restaurant) obj;
                System.out.println("There is a restaurant called \"" + restaurant.name + "\"");
            }

            else {
                System.out.println("There is something unknown...");
            }
        }
    }
}
